/* 1_sostituzione.c */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* FUNZIONE DA REALIZZARE
   ======================

   Un cifrario a sostituzione e' un tipo di codice in cui ogni lettera
   dell'alfabeto viene rimpiazzata da un'altra lettera (non
   necessariamente quella che segue di k posizioni come nel cifrario
   di Cesare). Supponendo che il messaggio in chiaro sia composto
   unicamente dalle 26 lettere minuscole (niente spazi, numeri o altri
   simboli), la chiave di un cifrario a sostituzione e' un array k[]
   di 26 caratteri, tale che il carattere 'a' del messaggio in chiaro
   viene rimpiazzato dal carattere k[0], il carattere 'b' viene
   rimpiazzato dal carattere k[1], e cosi' via fino a 'z' che viene
   rimpiazzato dal carattere k[25].

   Realizzare la funzione sostituzione(s, k) seguente, che accetta
   come parametri una stringa s di lunghezza arbitraria (anche zero) e
   un array k di 26 caratteri che rappresenta la chiave di cifratura
   da usare. La funzione deve restituire una NUOVA stringa, avente la
   stessa lunghezza di s, il cui contenuto corrisponde a quanto si
   ottiene cifrando s mediante un cifrario a sostituzione usando k
   come chiave. Si garantisce che s sia sempre composta solo da
   lettere minuscole.

   E' possibile usare le funzioni definite nell'header <string.h> (ad
   esempio, la funzione strlen()). E' anche possibile definire
   ulteriori funzioni se lo si ritiene necessario.

   Si ricorda che una funzione che supera i test non e' necessariamente
   corretta.
*/

char *sostituzione(char *s, char k[])
{
    return NULL;
}

/* Questa funzione non era richiesta nel testo, ma e' un utile
   esercizio: data una stringa s cifrata con un cifrario a
   sostituzione con chiave k[], restituisce una NUOVA stringa
   contenente la versione in chiaro di s. */
char *decifra(char *s, char k[])
{
    char *result = (char*)malloc((strlen(s)+1)*sizeof(char));
    char kdec[26]; /* chiave di decifratura */
    int i, j;
    /* data la chiave di cifratura k[], costruiamo la chiave di
       decifratura kdec[]. Al termine di questo ciclo, kdec[i]
       indica il carattere "in chiaro" che corrisponde al carattere
       cifrato ('a' + i) */
    for (j=0; j<26; j++) {
        kdec[k[j]-'a'] = 'a' + j;
    }
    for (i=0; s[i]; i++) {
        result[i] = kdec[s[i] - 'a'];
    }
    result[i] = '\0'; /* ricordiamo di terminare la stringa in chiaro */
    return result;
}

void test(char *s, char k[], char *expect)
{
    char *enc = sostituzione(s, k);
    if ( NULL != enc && 0 == strcmp(enc, expect) ) {
        printf("Test OK\n");
    } else {
        printf("Test FALLITO -- s=\"%s\": risultato atteso \"%s\", risultato ottenuto \"%s\"\n", s, expect, enc);
    }
    free(enc);
}

int main( void )
{
    char k0[] = "abcdefghijklmnopqrstuvwxyz";
    char k1[] = "bcdefghijklmnopqrstuvwxyza";
    char k2[] = "zabcdefghijklmnopqrstuvwxy";
    char k3[] = "yzijklabcdmnopefghuvwxqrst";

    test("", k0, "");
    test("prova", k0, "prova");
    test("messaggiodiprova", k0, "messaggiodiprova");
    test("ilmattinohaloroinbocca", k1, "jmnbuujopibmpspjocpddb");
    test("jmnbuujopibmpspjocpddb", k2, "ilmattinohaloroinbocca");
    test("ilmattinohaloroinbocca", k3, "cnoyvvcpebynehecpzeiiy");
    test("a", k3, "y");
    return 0;
}
