#include <stdio.h>
#include <stdlib.h>

/* Realizzare la funzione appendi(a, n, b, m) riportata sotto, in base
   alla specifica seguente. La funzione accetta in input due array a e
   b di interi, non vuoti, passati mediante puntatori, e le loro
   lunghezze n e m, rispettivamente.  La funzione deve restituire un
   puntatore ad un NUOVO array, allocato mediante la funzione
   malloc(), che contiene tutti i valori di a seguiti da tutti i
   valori di b. Si faccia riferimento ai test per esempi di
   funzionamento. */
int *appendi( int *a, int n, int *b, int m )
{
    return NULL;
}

/* restituisce 1 sse i due array a[] e b[] contengono gli stessi valori */
int array_equal(int *a, int n, int *b, int m)
{
    int i;
    if ( n != m )
        return 0;
    for (i=0; i<n; i++) {
        if ( a[i] != b[i] )
            return 0;
    }
    return 1;
}

void print_array(int *a, int n)
{
    int i;
    printf("[");
    for (i=0; i<n; i++) {
        printf("%d", a[i]);
        if ( i < n-1 ) {
            printf(",");
        }
    }
    printf("]");
}

void test(int *a, int n, int *b, int m, int *expect)
{
    int *r = appendi(a, n, b, m);
    int ok = array_equal(r, n+m, expect, n+m);
    printf("%s: ", (ok ? "Test OK" : "FALLITO"));
    print_array(a, n);
    printf("  ");
    print_array(b, m);
    printf(" -> ");
    print_array(r, n+m);
    printf("\n");
    free(r); /* ricordiamoci di liberare la memoria allocata da appendi() */
}

int main( void )
{
    int a1[] = {1, 2, 3};
    int a2[] = {4, 5, 6};
    int a1a2[] = {1, 2, 3, 4, 5, 6};

    int b1[] = {9, 10};
    int b2[] = {9, 1, 3, 2, 2, 3};
    int b1b2[] = {9, 10, 9, 1, 3, 2, 2, 3};

    int c1[] = {19}; 
    int c2[] = {9};
    int c1c2[] = {19, 9};

    int d1[] = {1, 1, 1};
    int d2[] = {3, 1, 4, 5};
    int d1d2[] = {1, 1, 1, 3, 1, 4, 5};

    test(a1, sizeof(a1)/sizeof(a1[0]), a2, sizeof(a2)/sizeof(a2[0]), a1a2);
    test(b1, sizeof(b1)/sizeof(b1[0]), b2, sizeof(b2)/sizeof(b2[0]), b1b2);
    test(c1, sizeof(c1)/sizeof(c1[0]), c2, sizeof(c2)/sizeof(c2[0]), c1c2);
    test(d1, sizeof(d1)/sizeof(d1[0]), d2, sizeof(d2)/sizeof(d2[0]), d1d2);
    return 0;
}
